package be.iminds.ilabt.jfed.espec.model;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;

/**
 * UploadSpec
 */
public class UploadSpec extends UploadLikeSpec {
    public UploadSpec(@Nonnull FileSource source,
                      @Nullable String path,
                      @Nullable String permissions,
                      @Nullable List<String> nodes) {
        super(source, path, permissions == null ? "u=rw" : permissions, nodes);

        //parser should check this, but another check here
        if (source == null)
            throw new IllegalArgumentException("upload must have a source");
    }

    @Override
    @Nonnull
    public FileSource getSource() {
        //Since it is checked in constructor, I'm sure this is not null
        //noinspection ConstantConditions
        return super.getSource();
    }
}
